﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Infragistics.Win;
using Infragistics.Win.UltraWinTree;

namespace WT_DifferentFormantsSameColumn
{
    class CustomDataFiler : IEditorDataFilter
    {
        public object Convert(EditorDataFilterConvertArgs conversionArgs)
        {
            if (conversionArgs.Direction == ConversionDirection.EditorToDisplay)
            {
                conversionArgs.Handled = true;
                conversionArgs.IsValid = true;

                var floatValue = (float)conversionArgs.Value;
                var cellUIElement = conversionArgs.Context as UltraTreeNodeCellUIElement;

                if (cellUIElement == null)
                {
                    return conversionArgs.Value;
                }

                var formatColumn = cellUIElement.Cell.Column.ColumnSet.Columns["Format"];
                var format = cellUIElement.Cell.Node.GetCellText(formatColumn);

                return floatValue.ToString(format);
            }
            return conversionArgs.Value;
        }
    }
}
